(function ($) {
    "use strict";

    $(window).on('elementor/frontend/init', function () {

        // Animated text
		var AnimatedText = function ($scope) {
			var $item = $scope.find('.cd-headline'),
				$settings = $item.data('settings'),
				$type = $settings.anim_type,
				$delay = $settings.delay,
				$clipDuration = $settings.clip_duration,
				$clipDelay = $settings.clip_delay,
				$typeLetterDelay = $settings.type_letter_delay,
				$selectionDuration = $settings.selection_duration,
				$typeAnimDelay = $settings.type_anim_delay,
				$barAnimDelay = $settings.bar_anim_delay,
				$barWaiting = $settings.bar_waiting;
			if( 'clip' === $type ){
				dlAnimatedText({
					selector: $item,
					animationDelay: $delay,
					revealDuration: $clipDuration,
					revealAnimationDelay: $clipDelay
				});
			}else if( 'letters type' === $type ) {
				dlAnimatedText({
					selector: $item,
					animationDelay: $delay,
					typeLettersDelay: $typeLetterDelay,
					selectionDuration: $selectionDuration,
					typeAnimationDelay: $typeAnimDelay,
				});
			}else if( 'loading-bar' === $type ) {
				dlAnimatedText({
					selector: $item,
					animationDelay: $delay,
					barAnimationDelay: $barAnimDelay,
					barWaiting: $barWaiting
				});
			}else{
				dlAnimatedText({
					selector: $item,
					animationDelay: $delay,
				});
			}
        };

        elementorFrontend.hooks.addAction( 'frontend/element_ready/dl-animated-heading.default', AnimatedText );
        
    });

})(jQuery);